DZ1.2/FERZid/Models/VrstaUloge.cs
using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;

namespace FERZid.Models
{
    public partial class VrstaUloge
    {
        public VrstaUloge()
        {
            UlogaOsobe = new HashSet<UlogaOsobe>();
        }

        public int IdvrsteUloge { get; set; }

        [Required]
        [StringLength(50, MinimumLength = 3)]
        public string Naziv { get; set; }

        public virtual ICollection<UlogaOsobe> UlogaOsobe { get; set; }
    }
}

DZ1.2/FERZid/ViewModels/VrstaUlogeViewModel.cs
using Microsoft.AspNetCore.Mvc.Rendering;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

namespace FERZid.Models
{
    public class VrstaUlogeViewModel
    {

        public int IdvrsteUloge { get; set; }
        public string Naziv { get; set; }

        public virtual ICollection<UlogaOsobe> UlogaOsobe { get; set; }


        public List<VrstaUloge> vrsteUloga;
        public SelectList vrstaUlogeSelectList;
        public string vrstaUloge { get; set; }
  

    }
}

DZ1.2/FERZid/Controllers/VrstaUlogeController.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.Rendering;
using Microsoft.EntityFrameworkCore;
using FERZid.Models;

namespace FERZid.Controllers
{
    public class VrstaUlogeController : Controller
    {
        private readonly RPPP08Context _context;

        public VrstaUlogeController(RPPP08Context context)
        {
            _context = context;    
        }

        // GET: VrstaUloge
        public async Task<IActionResult> Index(string searchString,string sortOrder,string currentFilter, string errorMessage, string successMessage, int page = 0)
        {

            ViewBag.CurrentSort = sortOrder;

            ViewBag.nazivSortParam = String.IsNullOrEmpty(sortOrder) ? "naziv_desc" : "";


            if (searchString != null)
            {
                page = 0;
            }

            else
            {
                searchString = currentFilter;
            }

            ViewBag.CurrentFilter = searchString;



            var uloge = from m in _context.VrstaUloge
                       select m;

            if (!String.IsNullOrEmpty(searchString))
            {
                uloge = uloge.Where(y => y.Naziv.Contains(searchString));
            }

            switch (sortOrder)
            {

                case "naziv_desc":
                    uloge = uloge.OrderByDescending(s => s.Naziv);
                    break;
             
                default:
                    uloge = uloge.OrderBy(s => s.Naziv);
                    break;
            }

            const int pageSize = 3;
            var count = uloge.Count();
            if (count == 0) page = 0;
            else if ((page * pageSize) >= count) --page;
            uloge = uloge.Skip(page * pageSize).Take(pageSize);
            this.ViewBag.MaxPage = (count / pageSize) - (count % pageSize == 0 ? 1 : 0);
            this.ViewBag.Page = page;

  

            var vrstaUlogeViewModel = new VrstaUlogeViewModel();
            
            vrstaUlogeViewModel.vrsteUloga= await uloge.ToListAsync();

            ViewData["Error"] = errorMessage;
            TempData["Success"] = successMessage;

            return View(vrstaUlogeViewModel);
        }

        // GET: VrstaUloge/Details/5
        public async Task<IActionResult> Details(int? id, int? previousDetail, int? nextDetail, string sortOrder, string currentFilter, int page)
        {
            if (id == null && previousDetail == null && nextDetail == null)
            {
                return NotFound();
            }

            var vrst = from m in _context.VrstaUloge
                             select m;
            List<VrstaUloge> uloge = await vrst.ToListAsync();


            if (previousDetail != null)
            {
                id = uloge.ElementAt((int)previousDetail).IdvrsteUloge;
            }

            if (nextDetail != null)
            {
                id = uloge.ElementAt((int)nextDetail).IdvrsteUloge;
            }

            var vrstaUloge = await _context.VrstaUloge
               .AsNoTracking()
               .Where(m => m.IdvrsteUloge == id)
               .Select(s => new VrstaUlogeViewModel
               {
                   IdvrsteUloge=s.IdvrsteUloge,
                   Naziv =s.Naziv
                })
               .FirstOrDefaultAsync();

            if (vrstaUloge == null)
            {
                return NotFound();
            }
            else
            {
                vrstaUloge.vrsteUloga = uloge;
                int indexAktualni = vrstaUloge.vrsteUloga.FindIndex(k => k.IdvrsteUloge == id);
                ViewBag.IndexAktualni = indexAktualni;
                ViewBag.NumberOfElements = vrstaUloge.vrsteUloga.Count();
            }

            ViewBag.Page = page;
            ViewBag.CurrentSort = sortOrder;
            ViewBag.CurrentFilter = currentFilter;

            return View(vrstaUloge);
        }

        // GET: VrstaUloge/Create
        public IActionResult Create()
        {
            return View();
        }

        // POST: VrstaUloge/Create
        // To protect from overposting attacks, please enable the specific properties you want to bind to, for 
        // more details see http://go.microsoft.com/fwlink/?LinkId=317598.
        [HttpPost]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> Create([Bind("IdvrsteUloge,Naziv")] VrstaUloge vrstaUloge)
        {
            string successMessage = null;

            if (ModelState.IsValid)
            {
                _context.Add(vrstaUloge);
                await _context.SaveChangesAsync();
                successMessage = "Vrsta uloge created: " + vrstaUloge.Naziv;
                return RedirectToAction("Index",new { successMessage=successMessage});
            }
            return View(vrstaUloge);
        }

        // GET: VrstaUloge/Edit/5
        public async Task<IActionResult> Edit(int? id, string sortOrder, string currentFilter, int page, string successMessage)
        {
            if (id == null)
            {
                return NotFound();
            }

            var vrstaUloge = await _context.VrstaUloge.SingleOrDefaultAsync(m => m.IdvrsteUloge == id);
            if (vrstaUloge == null)
            {
                return NotFound();
            }

            ViewBag.Page = page;
            ViewBag.CurrentFilter = currentFilter;
            ViewBag.CurrentSort = sortOrder;

            if (successMessage != null) TempData["Success"] = successMessage;
            return View(vrstaUloge);
        }

        // POST: VrstaUloge/Edit/5
        // To protect from overposting attacks, please enable the specific properties you want to bind to, for 
        // more details see http://go.microsoft.com/fwlink/?LinkId=317598.
        [HttpPost]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> Edit(int id, string sortOrder, string currentFilter, int page, [Bind("IdvrsteUloge,Naziv")] VrstaUloge vrstaUloge)
        {
            string successMessage = null;

            if (id != vrstaUloge.IdvrsteUloge)
            {
                return NotFound();
            }

            if (ModelState.IsValid)
            {
                try
                {
                    _context.Update(vrstaUloge);
                    await _context.SaveChangesAsync();
                }
                catch (DbUpdateConcurrencyException)
                {
                    if (!VrstaUlogeExists(vrstaUloge.IdvrsteUloge))
                    {
                        return NotFound();
                    }
                    else
                    {
                        throw;
                    }
                }
                successMessage = "Vrsta uloge edited: " + vrstaUloge.Naziv;
                return RedirectToAction("Edit", new { page = page, sortOrder = sortOrder, currentFilter = currentFilter, successMessage = successMessage });
            }
            return View(vrstaUloge);
        }

        // GET: VrstaUloge/Delete/5
        public async Task<IActionResult> Delete(int? id, string sortOrder, string currentFilter, int page)
        {
            if (id == null)
            {
                return NotFound();
            }

            var vrstaUloge = await _context.VrstaUloge
                .SingleOrDefaultAsync(m => m.IdvrsteUloge == id);
            if (vrstaUloge == null)
            {
                return NotFound();
            }

            //return View(vrstaUloge);
            return await DeleteConfirmed((int)id, sortOrder, currentFilter, page);
        }

        // POST: VrstaUloge/Delete/5
        [HttpPost, ActionName("Delete")]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> DeleteConfirmed(int id, string sortOrder, string currentFilter, int page)
        {
            string errorMessage = null;
            string successMessage = null;

            var vrstaUloge = await _context.VrstaUloge.SingleOrDefaultAsync(m => m.IdvrsteUloge == id);
            _context.VrstaUloge.Remove(vrstaUloge);
            try
            {
                await _context.SaveChangesAsync();
            }
            catch (DbUpdateException e)
            {
                errorMessage = "Vrsta uloge delete failed: " + vrstaUloge.Naziv;
            }

            if (errorMessage == null) successMessage = "Vrsta uloge deleted: " + vrstaUloge.Naziv;
            return RedirectToAction("Index", new { page = page, sortOrder = sortOrder, currentFilter = currentFilter, errorMessage = errorMessage, successMessage = successMessage }); 
        }

        private bool VrstaUlogeExists(int id)
        {
            return _context.VrstaUloge.Any(e => e.IdvrsteUloge == id);
        }
    }
}

DZ1.2/FERZid/Views/VrstaUloge/Create.cshtml
@model FERZid.Models.VrstaUloge

@{
    ViewData["Title"] = "Create";
}

<h2>Create</h2>

<form asp-action="Create">
    <div class="form-horizontal">
        <h4>VrstaUloge</h4>
        <hr />
        <div asp-validation-summary="ModelOnly" class="text-danger"></div>
        <div class="form-group">
            <label asp-for="Naziv" class="col-md-2 control-label"></label>
            <div class="col-md-10">
                <input asp-for="Naziv" class="form-control" />
                <span asp-validation-for="Naziv" class="text-danger"></span>
            </div>
        </div>
        <div class="form-group">
            <div class="col-md-offset-2 col-md-10">
                <input type="submit" value="Create" class="btn btn-default" />
            </div>
        </div>
    </div>
</form>

<div>
    <a asp-action="Index">Back to List</a>
</div>

@section Scripts {
    @{await Html.RenderPartialAsync("_ValidationScriptsPartial");}
}

DZ1.2/FERZid/Views/VrstaUloge/Delete.cshtml
@model FERZid.Models.VrstaUloge

@{
    ViewData["Title"] = "Delete";
}

<h2>Delete</h2>

<h3>Are you sure you want to delete this?</h3>
<div>
    <h4>VrstaUloge</h4>
    <hr />
    <dl class="dl-horizontal">
        <input type="hidden" asp-for="IdvrsteUloge" />
        <dt>
            @Html.DisplayNameFor(model => model.Naziv)
        </dt>
        <dd>
            @Html.DisplayFor(model => model.Naziv)
        </dd>
    </dl>
    
    <form asp-action="Delete">
        <div class="form-actions no-color">
            <input type="submit" value="Delete" onclick="return confirm('Are you sure you want to delete the record with id = @Model.IdvrsteUloge')" /> |
            <a asp-action="Index">Back to List</a>
        </div>
    </form>


</div>

DZ1.2/FERZid/Views/VrstaUloge/Details.cshtml
@model FERZid.Models.VrstaUlogeViewModel

@{
    ViewData["Title"] = "Details";
}

<h2>Details</h2>

<p align="left">
    @if (ViewBag.IndexAktualni > 0)
    {

        <a href="@Url.Action("Details","VrstaUloge", new { previousDetail = ViewBag.IndexAktualni - 1 })"
           class="btn btn-default">
            &laquo; Prev
        </a>


    }

    @if (ViewBag.IndexAktualni < ViewBag.NumberOfElements - 1)
    {

        <a href="@Url.Action("Details","VrstaUloge", new { nextDetail = ViewBag.IndexAktualni + 1 })"
           class="btn btn-default">
            Next &raquo;
        </a>

    }


</p>



<div>
    <h4>ID vrste uloge: @Html.DisplayFor(model => model.IdvrsteUloge)</h4>
    <hr />
    <dl class="dl-horizontal">
        <dt>
            @Html.DisplayNameFor(model => model.Naziv)
        </dt>
        <dd>
            @Html.DisplayFor(model => model.Naziv)
        </dd>

    </dl>
</div>
<div>

    @Html.ActionLink("Back to Vrste uloga list", "Index", "VrstaUloge", new { page = ViewBag.Page, sortOrder = ViewBag.CurrentSort, currentFilter = ViewBag.CurrentFilter })
</div>

DZ1.2/FERZid/Views/VrstaUloge/Edit.cshtml
@model FERZid.Models.VrstaUloge

@{
    ViewData["Title"] = "Edit";
}

<h2>Edit</h2>
<hr />

<br>

@if (TempData["Success"] != null)
{
    <div class="green">
        <p><strong>Success:</strong> @TempData["Success"].ToString()</p>
    </div>
}





<br>


<form asp-action="Edit" asp-route-page="@ViewBag.Page" asp-route-sortOrder="@ViewBag.CurrentSort" asp-route-currentFilter="@ViewBag.CurrentFilter">
    <div class="form-horizontal">
        <h4>VrstaUloge</h4>
        <hr />
        <div asp-validation-summary="ModelOnly" class="text-danger"></div>
    <input type="hidden" asp-for="IdvrsteUloge" />
        <div class="form-group">
            <label asp-for="Naziv" class="col-md-2 control-label"></label>
            <div class="col-md-10">
                <input asp-for="Naziv" class="form-control" />
                <span asp-validation-for="Naziv" class="text-danger"></span>
            </div>
        </div>
        <div class="form-group">
            <div class="col-md-offset-2 col-md-10">
                <input type="submit" value="Save" class="btn btn-default" />
            </div>
        </div>
    </div>
</form>



@section Scripts {
    @{await Html.RenderPartialAsync("_ValidationScriptsPartial");}
}

<div>
    @Html.ActionLink("Back to Vrste uloga list", "Index", "VrstaUloge", new { page = ViewBag.Page, sortOrder = ViewBag.CurrentSort, currentFilter = ViewBag.CurrentFilter })
</div>

DZ1.2/FERZid/Views/VrstaUloge/Index.cshtml
@model FERZid.Models.VrstaUlogeViewModel

@{
    ViewData["Title"] = "Vrste uloga";
}

<h2>Vrste uloga</h2>

<hr />
<p>
    <a style="margin-bottom:20px" class="btn btn-success btn" asp-action="Create" title="Dodaj vrstu uloge"><span class="glyphicon glyphicon-plus"></span>Dodaj vrstu uloge</a>
</p>
<br />

@using (Html.BeginForm("Index", "VrstaUloge", FormMethod.Get))
{
    <p align="right">
        Naziv: @Html.TextBox("searchString", ViewBag.CurrentFilter as string)
    </p>

        <p align="right">
            <input type="submit" value="Search" />
        </p>
}

@if (ViewData["Error"] != null)
{
    <div class="red">
        <p><strong>Error:</strong> @ViewData["Error"].ToString()</p>
    </div>
}
@if (TempData["Success"] != null)
{
    <div class="green">
        <p><strong>Success:</strong> @TempData["Success"].ToString()</p>
    </div>
}



<hr />

<br>


<table class="table table-striped" >
    <thead>
        <tr>
            <th>
                @Html.ActionLink("Naziv", "Index", new { sortOrder = ViewBag.nazivSortParam, currentFilter = ViewBag.CurrentFilter })
            </th>
            <th></th>
        </tr>
    </thead>
    <tbody>
        @foreach (var item in Model.vrsteUloga)
        {
            <tr>
                <td>
                    @Html.DisplayFor(modelItem => item.Naziv)
                </td>
                <td>
                    <div class="btn-group">
                        <button class="btn btn-default">
                            <a asp-action="Edit" asp-route-id="@item.IdvrsteUloge" asp-route-page="@ViewBag.Page" asp-route-sortOrder="@ViewBag.CurrentSort" asp-route-currentFilter="@ViewBag.CurrentFilter">
                                <span class="glyphicon glyphicon-pencil"></span>
                            </a>
                        </button>
                        <button class="btn btn-default">
                            <a asp-action="Details" asp-route-id="@item.IdvrsteUloge" asp-route-page="@ViewBag.Page" asp-route-sortOrder="@ViewBag.CurrentSort" asp-route-currentFilter="@ViewBag.CurrentFilter">
                                <span class="glyphicon glyphicon-zoom-in"></span>
                            </a>
                        </button>
                        <button class="btn btn-default">
                            <a asp-action="Delete" asp-route-id="@item.IdvrsteUloge" asp-route-page="@ViewBag.Page" asp-route-sortOrder="@ViewBag.CurrentSort" asp-route-currentFilter="@ViewBag.CurrentFilter" onclick="return confirm('Are you sure you want to delete the record with id = @item.IdvrsteUloge')">
                                <span class="glyphicon glyphicon-trash"></span>
                            </a>
                        </button>
                    </div>
                </td>
            </tr>
        }
    </tbody>
</table>

@section styles {
    <link rel="stylesheet" href="https://cdn.datatables.net/1.10.13/css/jquery.dataTables.min.css" />
}

@section scripts {
    <script src="https://cdn.datatables.net/1.10.13/js/jquery.dataTables.min.js"></script>

}


@if (ViewBag.Page > 0)
{
    <a href="@Url.Action("Index", new { page = ViewBag.Page - 1,sortOrder = ViewBag.CurrentSort, currentFilter = ViewBag.CurrentFilter})"
       class="btn btn-default">
        &laquo; Prev
    </a>
}
@if (ViewBag.Page < ViewBag.MaxPage)
{
    <a href="@Url.Action("Index", new { page = ViewBag.Page + 1,sortOrder = ViewBag.CurrentSort, currentFilter = ViewBag.CurrentFilter})"
       class="btn btn-default">
        Next &raquo;
    </a>
}
<hr />
@for (int i = 0; i <= ViewBag.MaxPage; i++)
{
    int j = i + 1;

    @if (ViewBag.Page == @i)
    {
        <ul class="pagination">
            <li>@Html.ActionLink(@j.ToString(), "Index", "VrstaUloge", new { page = @i, sortOrder = ViewBag.CurrentSort, currentFilter = ViewBag.CurrentFilter}, new { @style = "color:green;font-weight:bold;" })</li>
        </ul>
    }

    @if (ViewBag.Page != @i)
    {
        <ul class="pagination">
            <li>@Html.ActionLink(@j.ToString(), "Index", "VrstaUloge", new { page = @i, sortOrder = ViewBag.CurrentSort, currentFilter = ViewBag.CurrentFilter}, null)</li>
        </ul>
    }

}